#xL-ipchanger v1.1

# (C) 2003 xoLax

bind msg -|- !addip addip
bind msg -|- !delip delip
bind msg -|- !listip listip
bind msg o !ipchanges ipadds

set binary(ADDIP)       "/glftpd/bin/xl-ipchanger.sh"
set binary(CAT)         "/glftpd/bin/cat"
set binary(PASSCHK)     "/glftpd/bin/passchk"

set location(GLLOG)     "/glftpd/ftp-data/logs/glftpd.log"
set location(PASSWD)    "/glftpd/etc/passwd"
set location(USERS)     "/glftpd/ftp-data/users/"

set announce(ADDIP)     "Addip: %ip added to %user/%group .:xL-ipchanger v1.1 by xoLax:."
set announce(BADADDIP)  "IP not added to %user/%group - Wrong username/password .:xL-ipchanger v1.1 by xoLax:."
set announce(DELIP)     "Delip: %ip deleted from %user/%group .:xL-ipchanger v1.1 by xoLax:."
set announce(BADDELIP)  "IP not deleted from %user/%group - Wrong username/password .:xL-ipchanger v1.1 by xoLax:."
set announce(LISTIP)    "Match for %user/%group:"
set announce(BADLISTIP) "Wrong username/password! .:xL-ipchanger v1.1 by xoLax:."

set variables(ADDIP)    "%ircnick %user %group %ip %host"
set variables(DELIP)    "%ircnick %user %group %ip %host"
set variables(LISTIP)    "%ircnick %user %group %ip %host"

proc addip { nick host hand arg } {
 global location binary chanlist announce

 if { [llength $arg] != 3 } {
  set output "Usage: !addip <username> <password> <ident@ip>  .:xL-ipchanger v1.1 by xoLax:."
  }

 if { [llength $arg] == 3 } {
  set username [lindex $arg 0]
  set password [lindex $arg 1]
  set ip [lindex $arg 2]
  set result [exec $binary(PASSCHK) $username $password $location(PASSWD)]
  set group ""

  set userfile $location(USERS)$username
 

  if { ! [string compare $result "MATCH"] } {
   set output $announce(ADDIP)
   
   exec $binary(ADDIP) ADDIP $username $ip $nick $host

   foreach line [split [exec $binary(CAT) $userfile] "\n"] {
    if { ! [string compare [lindex $line 0] "GROUP"] } {
     set group [lrange $line 1 end]
     break
    }
   }
  } else { if { ! [string compare $result "NOMATCH"] } {
    set output $announce(BADADDIP)
   } else {
    set output $announce(BADADDIP)
   }
  }

  set output [replacevar $output "%ircnick" $nick]
  set output [replacevar $output "%user" $username]
  set output [replacevar $output "%host" $host]
  set output [replacevar $output "%group" $group]
  set output [replacevar $output "%ip" $ip]
  set output [basicreplace $output "ADDIP"]
  }

 putserv "PRIVMSG $nick :$output"

}

proc delip { nick host hand arg } {
 global location binary chanlist announce

 if { [llength $arg] != 3 } {
  set output "Usage: !delip <username> <password> <ident@ip>  .:xL-ipchanger v1.1 by xoLax:."
  }

 if { [llength $arg] == 3 } {
  set username [lindex $arg 0]
  set password [lindex $arg 1]
  set ip [lindex $arg 2]
  set result [exec $binary(PASSCHK) $username $password $location(PASSWD)]
  set group ""

  set userfile $location(USERS)$username


  if { ! [string compare $result "MATCH"] } {
   set output $announce(DELIP)

   exec $binary(ADDIP) DELIP $username $ip $nick $host

   foreach line [split [exec $binary(CAT) $userfile] "\n"] {
    if { ! [string compare [lindex $line 0] "GROUP"] } {
     set group [lrange $line 1 end]
     break
    }
   }
  } else { if { ! [string compare $result "NOMATCH"] } {
    set output $announce(BADDELIP)
   } else {
    set output $announce(BADDELIP)
   }
  }

  set output [replacevar $output "%ircnick" $nick]
  set output [replacevar $output "%user" $username]
  set output [replacevar $output "%host" $host]
  set output [replacevar $output "%group" $group]
  set output [replacevar $output "%ip" $ip]
  set output [basicreplace $output "DELIP"]
  }

 putserv "PRIVMSG $nick :$output"

}

proc listip { nick host hand arg } {
 global location binary chanlist announce

 if { [llength $arg] != 2 } {
  putserv "PRIVMSG $nick :Usage: !listip <username> <password> .:xL-ipchanger v1.1 by xoLax:."
  }

 if { [llength $arg] == 2 } {
  set username [lindex $arg 0]
  set password [lindex $arg 1]
  set result [exec $binary(PASSCHK) $username $password $location(PASSWD)]
  set group ""
  set ip ""

  set userfile $location(USERS)$username


  if { ! [string compare $result "MATCH"] } {
   set output $announce(LISTIP)

   #exec $binary(ADDIP) LISTIP $username $ip $nick $host

   foreach line [split [exec $binary(CAT) $userfile] "\n"] {
    if { ! [string compare [lindex $line 0] "GROUP"] } {
     set group [lrange $line 1 end]
     break
    }
   }

  set output [replacevar $output "%ircnick" $nick]
  set output [replacevar $output "%user" $username]
  set output [replacevar $output "%host" $host]
  set output [replacevar $output "%group" $group]
  set output [replacevar $output "%ip" $ip]
  set output [basicreplace $output "LISTIP"]


    foreach line [split [exec $binary(ADDIP) LISTIP $username $ip $nick $host] "\n"] {
      putquick "PRIVMSG $nick :$output $line"
  }

  } else { if { ! [string compare $result "NOMATCH"] } {
    set output $announce(BADLISTIP)
   } else {
    set output $announce(BADLISTIP)
   }
  putserv "PRIVMSG $nick :$output"
  }
  }

}

proc ipadds {nick output binary chan} {
 set binary "/glftpd/bin/xl-ipchanger.sh"
 foreach line [split [exec $binary IPADDS] "\n"] {
      putquick "PRIVMSG $nick :$line"
 }
}

putlog "xL-ipchanger v1.1 by xoLax loaded"


